import unittest, time, re
import os
import sys

from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import Select
from selenium.common.exceptions import NoSuchElementException
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities
from selenium.webdriver.common.proxy import *

import matplotlib
from datetime import datetime

import collector as cole

LOG_FILE = "log"

# RUNS = 1
# RELOADS = 2	# number of times neutral websites are reloaded to capture ads
# DELAY = 1
# 
# ID = 1
# INSTANCES = 8
# 
# AD_FILE = "ads1.txt"
# SITE_FILE = "men.txt"
# GENDER = 'm'


myProxy = "yogi.pdl.cmu.edu:3128"

proxy = Proxy({
    'proxyType': ProxyType.MANUAL,
    'httpProxy': myProxy,
    'ftpProxy': myProxy,
    'sslProxy': myProxy,
    'noProxy': '' # set this value as desired
    })


class Webdriver(unittest.TestCase):

	
	def setUp(self):
# 		chromedriver = "/Users/amitdatta/Desktop/chromedriver"
# 		os.environ["webdriver.chrome.driver"] = chromedriver
# 		self.driver = webdriver.Chrome(chromedriver)
# 		self.driver = webdriver.Remote(
#    				command_executor='http://localhost:4444/wd/hub',
#    				desired_capabilities=DesiredCapabilities.CHROME)
		self.driver = webdriver.Firefox(proxy=proxy)
		self.driver.implicitly_wait(10)
		self.base_url = "https://www.google.com/"
		self.verificationErrors = []
		self.driver.set_page_load_timeout(10)
		self.accept_next_alert = True
	
	def test_webdriver(self):
		driver = self.driver
		c = cole.Collector()
		# Log in to Google
#  		driver.find_element_by_xpath(".//a[span[span[@class='gbit']]]").click()
#  		self.driver.find_element_by_id("Email").send_keys("johng5332")
#  		self.driver.find_element_by_id("Passwd").send_keys("passwordjohng")
#  		self.driver.find_element_by_id("signIn").click()
#		self.driver.get("https://www.google.com/")
# 		driver.find_element_by_id("gbi4i").click()
# 		driver.find_element_by_id("gb_71").click()
		#raw_input("Waiting...")
		run = 0
        # Enable behavioral ads
		driver.get("https://www.google.com/settings/ads")
		driver.find_element_by_xpath(".//div[@class='Df Ec']").click()
		#print(str(ID)+"-"+c.get_gender(driver))
		### set Gender
		#c.set_gender(GENDER, driver)
		#c.train_with_sites(SITE_FILE, driver, ID)
 		#c.collect_ads(RELOADS, DELAY, AD_FILE, driver, ID)
 		list = ['BMW buy', 'Audi purchase', 'New cars', 'local Car dealers', 'autos and vehicles', 'cadillac prices', 'best limousines']#, 'private jets', 'buy chihuahua']
		#list = ['dog training', 'dog food', 'dog walking', 'dog clubs', 'caring for a puppy', 'trained dogs for sale', 'dog litter box']#, 'private jets', 'buy chihuahua']
		c.train_with_queries(list, 11, ID, driver)
		sys.exit()
		while (run < RUNS):
			#print(run)
			if(GENDER=='m'):
				#c.train_with_sites(SITE_FILE, driver, ID)
				c.wait_for_others(INSTANCES, ID)
			else:
				time.sleep(5)
				c.wait_for_others(INSTANCES, ID)
			#self.train_with_queries(list, visits, reloads)
			#raw_input("Waiting")
			#c.train_with_sites(SITE_FILE, driver, ID)
			c.collect_ads(RELOADS, DELAY, AD_FILE, driver, ID)
			run = run+1

    
	def tearDown(self):
		self.driver.quit()
		self.assertEqual([], self.verificationErrors)

if __name__ == "__main__":
	if len(sys.argv) != 7:
		sys.exit("SYNTAX: collector.py <id> <total-instances> <mode (m/f)> #runs #reloads #delay")
	global ID, INSTANCES, GENDER, AD_FILE, RUNS, RELOADS, DELAY
	ID = int(sys.argv[1])
	INSTANCES = int(sys.argv[2])
	GENDER = sys.argv[3]
	RUNS = int(sys.argv[4])
	RELOADS = int(sys.argv[5])
	DELAY = int(sys.argv[6])
	if (ID > INSTANCES):
		sys.exit("ERROR: id must be less than total instances")
	if(GENDER != 'm' and GENDER != 'f'):
		sys.exit("ERROR: Enter gender as (m/f)")
	AD_FILE = "ads"+str(ID)+".txt"
	if(GENDER == 'm'):
		SITE_FILE = "cars.txt"
	elif(GENDER == 'f'):
		SITE_FILE = "women.txt"
	
	
# 	fo = open(AD_FILE, "w")
# 	fo.close()
	
	AD_FILE = LOG_FILE
		
	del sys.argv[1:]
	unittest.main()
